--------------------------------------------------------------------------
-- localization.lua 
--------------------------------------------------------------------------

BINDING_HEADER_MOBILEFRAMES				= "Mobile Frames";
BINDING_NAME_TOGGLEUNITFRAMEANCHORS		= "Toggle Unit Frame Anchors";

MOBILE_FRAMES_REGULAR_HEADER				= "Regular Mobility Frames";
MOBILE_FRAMES_REGULAR_HEADER_INFO			= "Regular Mobility Frames";
MOBILE_FRAMES_SPECIAL_HEADER				= "Special Mobility Frames";
MOBILE_FRAMES_SPECIAL_HEADER_INFO			= "Special Mobility Frames";
MOBILE_FRAMES_TOGGLEANCHORS					= "Toggle Anchors";
MOBILE_FRAMES_TOGGLEANCHORS_INFO			= "Toggle Unit Frame Anchors";
MOBILE_FRAMES_ENABLE_SOUND					= "Enable Anchors Splash Sound";
MOBILE_FRAMES_ENABLE_SOUND_INFO				= "Enable the Splash Sound when you drop Anchor";
MOBILE_FRAMES_DOWN_ROLLSTACK				= "Stack Roll Windows Downwards.";
MOBILE_FRAMES_DOWN_ROLLSTACK_INFO			= "Make GroupLootFrames 2-4 stack downwards instead of upwards.";
MOBILE_FRAMES_SET_CONTAINERS_OFFSET			= "Set Container Offset";
MOBILE_FRAMES_SET_CONTAINERS_OFFSET_INFO	= "";
MOBILE_FRAMES_SET_UIPANEL_OFFSET			= "Set Regular Frames Offset";
MOBILE_FRAMES_SET_UIPANEL_OFFSET_INFO   	= "";

MOBILE_FRAMES_HEADER				= "Mobile Frames";
MOBILE_FRAMES_HEADER_INFO			= "Makes selected frames mobile by dragging their top bar.";
MOBILE_FRAMES_ENABLE_TEXT			= "Enable %s.";
MOBILE_FRAMES_ENABLE_TEXT_INFO		= "Allows %s to be dragged by its top bar.";
MOBILE_FRAMES_ENABLED_TEXT			= "Enabled Mobile %s.";
MOBILE_FRAMES_DISABLED_TEXT			= "Disabled Mobile %s.";
MOBILE_FRAMES_ENABLED_ALL_TEXT  	= "Enabled All Mobile Frames.";
MOBILE_FRAMES_DISABLED_ALL_TEXT 	= "Disabled All Mobile Frames.";
MOBILE_FRAMES_RESET_ALL				= "All Mobile Frame Positions Reset.";
MOBILE_FRAMES_RESET					= "Mobile Frame (%s) Position Reset.";
MOBILE_FRAMES_RESET_TEXT			= "Reset %s.";
MOBILE_FRAMES_RESET_TEXT_INFO		= "Reset the position of %s.";
MOBILE_FRAMES_RESET_ALL_TEXT		= "Reset All Mobile Frames.";
MOBILE_FRAMES_RESET_ALL_TEXT_INFO	= "Reset the position of all Mobile Frames.";
MOBILE_FRAMES_ENABLE_ALL_TEXT		= "Enable All Mobile Frames.";
MOBILE_FRAMES_ENABLE_ALL_TEXT_INFO	= "Allows all mobile frames to be dragged by their top bar.";
MOBILE_FRAMES_DISABLE_ALL_TEXT		= "Disable All Mobile Frames.";
MOBILE_FRAMES_DISABLE_ALL_TEXT_INFO	= "Disallows the repositioning of mobile frames.";
MOBILE_FRAMES_ERROR					= "Mobile Frame Not Found.";
MOBILE_FRAMES_TOOLTIP_TEXT			= "Click to drag %s.\nShift-Right-Click for reset menu.";

MOBILE_FRAMES_SOUND_FEEDBACK_ENABLED				= "Will play a splashing noise when anchors are hidden.";
MOBILE_FRAMES_SOUND_FEEDBACK_DISABLED				= "Will not play sounds for mobile frames.";
MOBILE_FRAMES_ROLLSTACK_FEEDBACK_ENABLED			= "GroupLootFrames 2-4 will now stack downwards instead of upwards.";
MOBILE_FRAMES_ROLLSTACK_FEEDBACK_DISABLED			= "GroupLootFrames 2-4 will now stack upwards (default).";
MOBILE_FRAMES_CONTAINERS_OFFSET_FEEDBACK_ENABLED	= "Will offset your bags by %s pixels.";
MOBILE_FRAMES_CONTAINERS_OFFSET_FEEDBACK_DISABLED	= "Will not offset your bags.";
MOBILE_FRAMES_UIPANEL_OFFSET_FEEDBACK_ENABLED		= "Will offset the UI Panels by %s pixels.";
MOBILE_FRAMES_UIPANEL_OFFSET_FEEDBACK_DISABLED		= "Will not offset the UIPanel.";

DISABLE_ALL		= "Disable All";
ENABLE_ALL		= "Enable All";
RESET_ALL		= "Reset All";
OFFSET			= "Offset";
RESET			= "Reset";

-- Slash Commands
SLASH_MOBILEFRAMES1	= "/mobileframes";
SLASH_MOBILEFRAMES2	= "/mobile";

MOBILE_FRAMES_SLASH_LIST		= "list";
MOBILE_FRAMES_SLASH_ENABLE		= "enable";
MOBILE_FRAMES_SLASH_DISABLE		= "disable";
MOBILE_FRAMES_SLASH_RESET		= "reset";
MOBILE_FRAMES_SLASH_ANCHORS		= "anchors";
MOBILE_FRAMES_SLASH_SOUND		= "sound";
MOBILE_FRAMES_SLASH_OFFSET		= "offset";
MOBILE_FRAMES_SLASH_ROLLSTACK	= "rollstack";

MOBILE_FRAMES_SLASH_UIPANEL_OFFSET		= "uipanel";
MOBILE_FRAMES_SLASH_CONTAINERS_OFFSET	= "bags";


-- Slash Command Help
MOBILE_FRAMES_HELP_TITLE				= "**MobileFrames Help**";
MOBILE_FRAMES_HELP_SUMMARY				= "MobileFrames: Makes selected frames mobile by dragging their top/title bar or special frame anchor.";
MOBILE_FRAMES_HELP_MAIN					= "|cffffffff/mobile -|r Print slash command help,";
MOBILE_FRAMES_HELP_LIST					= "|cffffffff/mobile list -|r Print a list of movable UI panels and frames,";
MOBILE_FRAMES_HELP_ENABLE				= "|cffffffff/mobile enable [frameName] -|r Enable the mobility of a frame (all if not specified),";
MOBILE_FRAMES_HELP_DISABLE				= "|cffffffff/mobile disable [frameName] -|r Disable the mobility of a frame (all if not specified),";
MOBILE_FRAMES_HELP_RESET				= "|cffffffff/mobile reset [frameName] -|r Reset the position of a frame (all if not specified),";
MOBILE_FRAMES_HELP_ANCHORS				= "|cffffffff/mobile anchors -|r Toggle the visibility of special frame anchors,";
MOBILE_FRAMES_HELP_SOUND				= "|cffffffff/mobile sound -|r Toggle the splash sound when special frame anchors are hidden,";
MOBILE_FRAMES_HELP_UIPANEL_OFFSET		= "|cffffffff/mobile offset uipanel <#> -|r Set the offset for regular windows from the left side of the screen,";
MOBILE_FRAMES_HELP_CONTAINERS_OFFSET	= "|cffffffff/mobile offset bags <#> -|r Set the offset for bags from the right side of the screen,";
MOBILE_FRAMES_HELP_ROLLSTACK			= "|cffffffff/mobile rollstack -|r Toggle group loot window stacking down or up.";

MOBILE_FRAMES_LIST_MOVABLE_TITLE		= "**List of Movable UI Frames**";
MOBILE_FRAMES_LIST_MOVABLE_TOTAL		= "(%s) movable frames.";
MOBILE_FRAMES_LIST_VISIBLE_TITLE		= "**List of Visible UI Frames**";
MOBILE_FRAMES_LIST_VISIBLE_TOTAL		= "(%s) visible frames.";

-- Frame Names
MOBILE_FRAMES_FRAMEDESCRIPTIONS = {};
MOBILE_FRAMES_FRAMEDESCRIPTIONS.LootFrame						= "Loot Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.QuestLogFrame					= "Questlog Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TradeFrame						= "Trade Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MerchantFrame					= "Merchant Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.ClassTrainerFrame				= "Class Trainer Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TradeSkillFrame					= "Tradeskill Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MacroFrame						= "Macro Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.FriendsFrame					= "Friends Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.CharacterFrame					= "Character Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.SpellBookFrame					= "Spellbook Frame";  
MOBILE_FRAMES_FRAMEDESCRIPTIONS.InspectFrame					= "Inspect Frame";  
MOBILE_FRAMES_FRAMEDESCRIPTIONS.CraftFrame						= "Craft Frame";  
MOBILE_FRAMES_FRAMEDESCRIPTIONS.BankFrame						= "Bank Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.QuestFrame						= "Quest Frame"; 
MOBILE_FRAMES_FRAMEDESCRIPTIONS.GossipFrame						= "Gossip Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.GuildRegistrarFrame				= "Guild Registrar Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.ItemTextFrame					= "Item Text Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TabardFrame						= "Tabard Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.PetStableFrame					= "Pet Stable Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.Containers						= "Bags";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.PlayerFrame						= "Player Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TargetFrame						= "Target Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.PartyMemberFrames				= "Party Member Frames";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.BottomMultiBars					= "Bottom Multi Bars";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.SideMultiBars					= "Side Multi Bars";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MinimapCluster					= "Minimap";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.AuctionFrame					= "Auction Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TalentFrame						= "Talent Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.PetFrame						= "Pet Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MailFrame						= "Mail Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.OpenMailFrame					= "Open Mail Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.QuestWatchFrame					= "Quest Watch Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.FramerateLabel					= "Framerate";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.DurabilityFrame					= "Durability Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TicketStatusFrame				= "Ticket Status Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TemporaryEnchantFrame			= "Buffs";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.GroupLootFrame					= "Group Loot Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.BattlefieldFrame				= "Battlefield Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.WorldStateScoreFrame			= "World State Score Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.GroupLootFrame					= "Group Loot Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.CastingBarFrame					= "Casting Bar";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.DressUpFrame					= "Dress Up Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.TaxiFrame						= "Flight Path Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.DressUpFrame					= "Dress Up Frame";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MainMenuBar						= "Main Menu Bar";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.BackpackButtons					= "Backpack Buttons";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.MicroButtons					= "Micro Buttons";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.ActionButtons					= "Action Bar";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.ShapeshiftBarFrame				= "Shapeshift Bar";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.PetActionBarFrame				= "Pet Action Bar";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.WorldStateAlwaysUpFrame			= "Arathi Basin Scores";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.UIErrorsFrame					= "UI Errors Banner";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.DivineBlessingFrame				= "Divine Blessing";
MOBILE_FRAMES_FRAMEDESCRIPTIONS.QuestTimerFrame					= "Quest Timer Frame";

